/* bake.vapi generated by valac 0.42.4, do not modify. */

namespace Bake {
	[CCode (cheader_filename = "bake.h")]
	public class Block : GLib.Object {
		public string id;
		public Bake.Recipe recipe;
		public Block (Bake.Recipe recipe, string type_name, string id);
		public bool get_boolean_variable (string name, bool? fallback = false);
		public GLib.List<Bake.TaggedEntry> get_tagged_list (string name) throws Bake.TaggedListError;
		public string? get_variable (string name, string? fallback = null);
	}
	[CCode (cheader_filename = "bake.h")]
	public class BuildModule : GLib.Object {
		public BuildModule ();
		public virtual bool can_generate_library_rules (Bake.Library library) throws GLib.Error;
		public virtual bool can_generate_program_rules (Bake.Program program) throws GLib.Error;
		public virtual void generate_data_rules (Bake.Data data) throws GLib.Error;
		public virtual void generate_library_rules (Bake.Library library) throws GLib.Error;
		public virtual void generate_program_rules (Bake.Program program) throws GLib.Error;
		public virtual void generate_toplevel_rules (Bake.Recipe toplevel);
		public virtual void recipe_complete (Bake.Recipe recipe);
		public virtual void rules_complete (Bake.Recipe toplevel);
	}
	[CCode (cheader_filename = "bake.h")]
	public class Builder : GLib.Object {
		public string base_directory;
		public Builder (string base_directory, Bake.BuilderFlags flags = 0);
		public async bool build (Bake.Recipe recipe) throws Bake.BuildError;
		public async bool build_target (Bake.Recipe recipe, string target) throws Bake.BuildError;
		public async bool clean (Bake.Recipe recipe) throws Bake.BuildError;
		public async bool install (Bake.Recipe recipe) throws Bake.BuildError;
		public async bool release (Bake.Recipe recipe) throws Bake.BuildError;
		public async bool test (Bake.Recipe recipe) throws Bake.BuildError;
		public async bool uninstall (Bake.Recipe recipe) throws Bake.BuildError;
		public signal void report_command (string text);
		public signal void report_debug (string text);
		public signal void report_output (string text);
		public signal void report_status (string text);
	}
	[CCode (cheader_filename = "bake.h")]
	public class CleanRule : Bake.Rule {
		protected GLib.List<string> clean_files;
		public CleanRule (Bake.Recipe recipe, bool pretty_print);
		public void add_clean_file (string file);
		public override GLib.List<string> get_commands ();
	}
	[CCode (cheader_filename = "bake.h")]
	public class Compilable : Bake.Block {
		public Compilable (Bake.Recipe recipe, string type_name, string id);
		public string? get_flags (string name, string? fallback = null);
		public unowned GLib.List<Bake.TaggedEntry> get_packages () throws GLib.Error;
		public unowned GLib.List<Bake.TaggedEntry> get_sources () throws GLib.Error;
		public string? compile_flags { owned get; }
		public string? compiler { owned get; }
		public bool debug { get; }
		public string? gettext_domain { owned get; }
		public bool install { get; }
		public string? link_flags { owned get; }
		public string name { owned get; }
	}
	[CCode (cheader_filename = "bake.h")]
	public class Cookbook : GLib.Object {
		public Bake.Recipe current_recipe;
		public GLib.List<Bake.Option> options;
		public string toplevel_dir;
		public Cookbook (string original_dir, bool pretty_print = true);
		public void configure (string[] args) throws Bake.CookbookError;
		public bool generate_rules () throws GLib.Error;
		public void load () throws Bake.CookbookError, Bake.RecipeError;
		public void unconfigure () throws Bake.CookbookError;
		public bool needs_configure { get; }
		public signal void report_debug (string text);
		public signal void report_status (string text);
	}
	[CCode (cheader_filename = "bake.h")]
	public class Data : Bake.Block {
		public Data (Bake.Recipe recipe, string id);
		public string? gettext_domain { owned get; }
		public bool install { get; }
		public string install_directory { owned get; }
	}
	[CCode (cheader_filename = "bake.h")]
	public class Library : Bake.Compilable {
		public Library (Bake.Recipe recipe, string id);
		public string install_directory { owned get; }
	}
	[CCode (cheader_filename = "bake.h")]
	public class Option : Bake.Block {
		public Option (Bake.Recipe recipe, string id);
		public string @default { owned get; }
		public string description { owned get; }
		public string? value { owned get; set; }
	}
	[CCode (cheader_filename = "bake.h")]
	public class Program : Bake.Compilable {
		public Program (Bake.Recipe recipe, string id);
		public string install_directory { owned get; }
	}
	[CCode (cheader_filename = "bake.h")]
	public class Recipe : GLib.Object {
		public Bake.Rule build_rule;
		public GLib.List<Bake.Recipe> children;
		public Bake.CleanRule clean_rule;
		public string filename;
		public Bake.Rule install_rule;
		public Bake.Recipe? parent;
		public bool pretty_print;
		public GLib.List<Bake.Rule> rules;
		public GLib.HashTable<string,Bake.Rule> targets;
		public Bake.Rule test_rule;
		public Bake.Rule uninstall_rule;
		public GLib.List<string> variable_names;
		public Recipe (bool pretty_print);
		public void add_install_link_rule (string filename, string install_dir, string target);
		public void add_install_rule (string filename, string install_dir, string? target_filename = null);
		public Bake.Rule add_rule ();
		public Bake.Rule? find_rule (string output);
		public Bake.Rule? find_rule_recursive (string output);
		public Recipe.from_file (string filename, Bake.RecipeLoadFlags flags = RecipeLoadFlags.NONE) throws GLib.FileError, Bake.RecipeError;
		public void generate_clean_rule ();
		public bool get_boolean_variable (string name, bool fallback = false);
		public string get_build_path (string path, bool important = false);
		public string get_install_path (string path);
		public Bake.Rule? get_rule_with_target (string target);
		public string? get_variable (string name, string? fallback = null, bool recurse = true);
		public GLib.List<string> get_variable_children (string name);
		public void set_variable (string name, string? value, int line_number = -1);
		public string substitute_variables (string line);
		public string to_string ();
		public string binary_directory { owned get; }
		public string build_directory { owned get; }
		public string data_directory { owned get; }
		public string dirname { owned get; }
		public string include_directory { owned get; }
		public string install_directory { owned get; }
		public bool is_toplevel { get; }
		public string library_directory { owned get; }
		public string project_data_directory { owned get; }
		public string project_name { owned get; }
		public string project_version { owned get; }
		public string relative_dirname { owned get; }
		public string release_directory { owned get; }
		public string release_name { owned get; }
		public string system_binary_directory { owned get; }
		public string system_library_directory { owned get; }
		public Bake.Recipe toplevel { get; }
	}
	[CCode (cheader_filename = "bake.h")]
	public class Rule : GLib.Object {
		public GLib.List<string> inputs;
		public GLib.List<string> outputs;
		protected bool pretty_print;
		public Bake.Recipe recipe;
		protected GLib.List<string> static_commands;
		public Rule (Bake.Recipe recipe, bool pretty_print);
		public void add_command (string command);
		public void add_error_command (string status);
		public void add_input (string input);
		public void add_output (string output);
		public void add_status_command (string status);
		public virtual GLib.List<string> get_commands ();
		public bool has_command (string command);
		protected string make_status_command (string status);
		public string to_string ();
	}
	[CCode (cheader_filename = "bake.h")]
	public class TaggedEntry : GLib.Object {
		public string name;
		public Bake.Recipe recipe;
		public GLib.List<string> tags;
		public TaggedEntry (Bake.Recipe recipe, string name);
		public bool has_tag (string name);
		public bool is_allowed { get; }
	}
	[CCode (cheader_filename = "bake.h")]
	public class Template : Bake.Block {
		public Template (Bake.Recipe recipe, string id);
	}
	[CCode (cheader_filename = "bake.h")]
	public enum BuilderFlags {
		PRETTY_PRINT,
		DEBUG,
		PARALLEL
	}
	[CCode (cheader_filename = "bake.h")]
	public enum RecipeLoadFlags {
		NONE,
		PRETTY_PRINT,
		DISALLOW_RULES,
		STOP_IF_TOPLEVEL
	}
	[CCode (cheader_filename = "bake.h")]
	public errordomain BuildError {
		ERROR
	}
	[CCode (cheader_filename = "bake.h")]
	public errordomain CookbookError {
		INVALID_CONFIG,
		NO_RECIPE,
		NO_TOPLEVEL,
		INVALID_RECIPE,
		INVALID_DIRECTORY,
		TOO_OLD,
		INVALID_ARGUMENT,
		UNKNOWN_OPTIONS
	}
	[CCode (cheader_filename = "bake.h")]
	public errordomain RecipeError {
		INVALID
	}
	[CCode (cheader_filename = "bake.h")]
	public errordomain TaggedListError {
		TAG_BEFORE_ENTRY,
		UNTERMINATED_TAG
	}
	[CCode (cheader_filename = "bake.h")]
	public static string get_relative_path (string source_path, string target_path);
	[CCode (cheader_filename = "bake.h")]
	public static string join_relative_dir (string base_dir, string relative_dir);
	[CCode (cheader_filename = "bake.h")]
	public static string remove_extension (string filename);
	[CCode (cheader_filename = "bake.h")]
	public static string replace_extension (string filename, string extension);
}
[CCode (cheader_filename = "bake.h")]
public class RequireEntry {
	public string? condition;
	public bool is_private;
	public string name;
	public string? version;
	public RequireEntry ();
	public bool check_version (string version);
}
[CCode (cheader_filename = "bake.h")]
public const string VERSION;
[CCode (cheader_filename = "bake.h")]
public const string LIBRARY_DIRECTORY;
[CCode (cheader_filename = "bake.h")]
public const string GETTEXT_PACKAGE;
[CCode (cheader_filename = "bake.h")]
public static GLib.List<string> split_variable (string value);
